#include "channel.h"

static struct channel *hash[CHANNEL_HASH_SIZE];

/* Channel hashing algorithm - Description
 * hmm, I don't know much about hashing algorithms, so this one is 
 * (almost) right out of an A-Level text book :)  
 * I need to find a better one, i modd'ed it to be case insenstive :) 
 * and voila, there it is, overflow is handled via a 1, then 2 effect */


/* get a pointer to a specific channel */
struct channel * locate_channel(char *name)
{
	int char_total,i,subscript,check;
	
	/* Add up ASCII codes */
	char_total=0;
	

	for(i=1;name[i]!='\0';i++) {
		if(name[i] < 95 ) {	
			char_total += 2 * (name[i]+32);
		} else {
			char_total += 2 * (name[i]);
		}
	}
	
	subscript = (int) char_total/CHANNEL_HASH_SIZE;
	while(subscript>=CHANNEL_HASH_SIZE) 
		subscript-=CHANNEL_HASH_SIZE;
	

	check=0;
	for(i=1;check==0;i=2*i) {
		if(hash[subscript]==NULL || lc_strncmp(name,hash[subscript]->name,-1)==0) {
			check=1;
		} else {
			subscript+=i;
			while(subscript>=CHANNEL_HASH_SIZE) {
				subscript-=CHANNEL_HASH_SIZE;
			}
		}		
	}
	if(hash[subscript]==NULL) {
		return NULL;
	} else {
		return hash[subscript];	
	}
		
}

/* Add a channel to the hash */
int add_channel(struct channel * addme) 
{
	int char_total,i,subscript;
	
	char_total=0;

	for(i=1;addme->name[i]!='\0';i++) {
		if(addme->name[i] < 95 ) {
			char_total+= 2 *(addme->name[i] + 32);
		} else {
			char_total+= 2 *(addme->name[i]);
		}
	}

	subscript=(int) char_total/CHANNEL_HASH_SIZE;
	while(subscript>=CHANNEL_HASH_SIZE)
		subscript-=CHANNEL_HASH_SIZE;

	for(i=1;hash[subscript]!=NULL;i=i*2) {
		subscript+=i;
		while(subscript>=CHANNEL_HASH_SIZE)
			subscript-=CHANNEL_HASH_SIZE;
	}
	
	hash[subscript]=addme;
		
	return EXIT_SUCCESS;
}

/* Remove a channel from the hash */
/* doesn't actually free() it, though */
int remove_channel(struct channel * killme)
{
 	int char_total,i,subscript;

	char_total=0;

	for(i=1;killme->name[i]!='\0';i++) {
		if(killme->name[i] < 95 ) {
			char_total+=2*(killme->name[i] + 32);
		} else {
			char_total+=2*(killme->name[i]);
		}
	}
				

	subscript=(int) char_total/CHANNEL_HASH_SIZE;
	while(subscript>=CHANNEL_HASH_SIZE) 
		subscript-=CHANNEL_HASH_SIZE;

	for(i=1;killme!=hash[subscript];i=i*2) {
		subscript+=i;
		while(subscript>=CHANNEL_HASH_SIZE)
			subscript-=CHANNEL_HASH_SIZE;
	}
	
	hash[subscript]=NULL;
	
	return EXIT_SUCCESS;
}

/* Initialise hash table */
int prepare_hash()
{
	int i;

	for(i=0;i<CHANNEL_HASH_SIZE;i++) 
		hash[i]=NULL;

	return EXIT_SUCCESS;
}

/* remove a client from the channel client list */
int rem_client_chan(struct clientinfo *client,struct channel *chan)
{
	struct user_wrap *curr_user=NULL;
	struct user_wrap *prev_user=NULL;

	curr_user=chan->users_start;

	while(curr_user!=NULL) {
		if(curr_user->user_info==client) {
			if(curr_user==chan->users_start) {
				chan->users_start=curr_user->next;
			} else {
				prev_user->next=curr_user->next;
			}
			free(curr_user);
			return EXIT_SUCCESS;
		} else {
			prev_user=curr_user;
			curr_user=curr_user->next;
		}
	}
	return EXIT_FAILURE;
}

			
