#ifndef _CLIENT_H_

#define _CLIENT_H_

#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include "config_file.h"
#include "client.h"

#define CLIENT_OK 	EXIT_SUCCESS
#define CLIENT_FAILED 	EXIT_FAILURE

#define NICK_LENGTH 		20
#define	USER_LENGTH 		15
#define HOST_LENGTH 		60
#define REAL_NAME_LENGTH 	20
#define CHANNELS_PER_USER	6

/* flags set on a user */
#define USR_HOST 	1
#define USR_NICK 	2
#define USR_NAME 	4
#define USR_LIST 	8
#define USR_LOGGEDIN	16
#define USR_PINGSENT 	32

/* modes on a user */
#define MODE_AWAY	2
#define MODE_WALLOPS	4
#define MODE_INVIS	8
#define MODE_RESTRICT	16
#define MODE_IRCOP	32
#define MODE_LOCOP	64
#define MODE_SERVNOT	128

struct chan_wrap {
	/* Next in list */
	struct chan_wrap *next;
	/* Channel info */
	struct channel *chan_info;
};

/* Core client structure */
/* One per client in memory */
struct clientinfo {
	/* Tree pointers */
	struct clientinfo * left;
	struct clientinfo * right;
	struct clientinfo * parent;
	/* Fd for client */
	int fd;
	/* Client mode */
	int mode;
	/* Server-only flags */
	int flags;
	/* Last message receipt */
	time_t lastrecv;
	/* Info about user */
	char host[HOST_LENGTH];
	char nick[NICK_LENGTH];
	char user[USER_LENGTH];
	char real_name[REAL_NAME_LENGTH];
	/* Channel list start */
	struct chan_wrap *chan_start;
};


/* makes life easier for linked list stuff */
#define list_next left
#define list_prev right

int add_client(char *,char *,char *);
int add_client_struct(struct clientinfo *);
int remove_client(char *);
struct clientinfo * locate_client(char *);
/* only for debugging */
int list_tree();

#endif
