#include "cmd_mode.h"

/* Needs some new stuff appending, no major hassles */

/* cmd_mode - deals with MODE commands */
int cmd_mode(struct clientinfo *sender,struct parsed_cmd *cmd)
{
	char buffer[BUF_SIZE];
	int i,j,addtake;
	
	/* Check for correct params */
	if(check_channel(cmd->params[0])) {
		/* Its a channel, call correct functions */
		return cmd_mode_channel(sender,cmd);
	}
	
	if(cmd->params[1]==NULL) {
		ircd_sprintf(buffer,BUF_SIZE,"%s :Not Enough Parameters",cmd->command);
		send_numeric(sender->fd,sender->nick,461,buffer);
		cmd_free(cmd);
		return EXIT_FAILURE;
	} else {
		if(lc_strncmp(cmd->params[0],sender->nick,-1)) {
			/* Parse cmd->params[1..4] */
			addtake=0;
			for(j=1;cmd->params[j]!=NULL;j++) {
				for(i=0;(cmd->params[j])[i]!='\0';i++) {
					switch((cmd->params[j])[i]) {
						case '+':
							addtake=1;
							break;
						case '-':
							addtake=-1;
							break;
						case 'i':
							if(addtake==-1) {
								sender->flags ^= MODE_INVIS;
								break;
							} 
							if(addtake==1) {
								sender->flags |= MODE_INVIS;
								break;
							} 
							break;
						case 'w':
							if(addtake==-1) {
								sender->flags ^= MODE_WALLOPS;
								break;
							} 
							if(addtake==1) {
								sender->flags |= MODE_WALLOPS;
								break;
							}
							break;
						case 'r':
							if(addtake==-1) {
								sender->flags ^= MODE_RESTRICT;
								break;
							} 
							/* User cannot unrestrict themselves */
							break;
						case 's':
							if(addtake==-1) {
								sender->flags ^= MODE_SERVNOT;
								break;
							}
							if(addtake==1) {
								sender->flags |= MODE_SERVNOT;
								break;
							}
							break;
						default:
							break;
					}
				}
			}
		}
		cmd_free(cmd);
		return EXIT_SUCCESS;
	}
		
}

/* channel mode thingy */
/* determines whether to set channel mode, return channel mode
 * or to set a user channel mode (+o -v etc) */
static int cmd_mode_channel(struct clientinfo *client,struct parsed_cmd *cmd)
{
	struct channel * chan;
	struct user_wrap *curr_user;
	char buffer[BUF_SIZE];
	int found;

	/* Locate channel */	
	chan=locate_channel(cmd->params[0]);
	
	/* If channel doesn't exist */
	if(chan==NULL) {
		/* Channel doesn't exist */
		/* Inform user */
		ircd_sprintf(buffer,BUF_SIZE,"%s :No Such Channel",cmd->params[0]);
		send_numeric(client->fd,client->nick,403,buffer);
		return cmd_free(cmd);	
	}
	
	/* Check user is on that channel */
	curr_user=chan->users_start;
	found=0;
	while(curr_user!=NULL && found==0) {
		if(curr_user->user_info==client) {
			found=1;
		} else {
			curr_user=curr_user->next;
		}
	}
	if(found==0) {
		/* Inform user they're not on that channel */
		ircd_sprintf(buffer,BUF_SIZE,"%s :You're not on that channel",chan->name);
		send_numeric(client->fd,client->nick,442,buffer);
		cmd_free(cmd);
		return EXIT_SUCCESS;
	}

	if(cmd->params[1]==NULL) {
		/* Report current channel mode to user */	
		send_chancurr_mode(client,chan);
		cmd_free(cmd);
		return EXIT_SUCCESS;
	} else {
		/* Set modes */
		if(cmd->params[2]!=NULL ) {
			/* curr_user still points to user requesting to change mode */	
			if( (curr_user->chan_mode & CHANUSR_OP) || (client->mode & MODE_IRCOP)) {
				/* They can do it */
				chanuser_mode_set(client,chan,cmd);
				cmd_free(cmd);
				return EXIT_SUCCESS;
			} else {
			       /* They don't have ops :( */
				ircd_sprintf(buffer,BUF_SIZE,"%s :Ha! You're not a Chan op",chan->name);
				send_numeric(client->fd,client->nick,482,buffer);
				cmd_free(cmd);
				return EXIT_SUCCESS;
			}
		} else {
			/* Set channel mode */
			/* Check for op privledges */
			if(curr_user->chan_mode & CHANUSR_OP) {	
				/* They're an op */
				set_chan_mode(client,chan,cmd);	
			} else {
				/* They don't have ops :( */
				ircd_sprintf(buffer,BUF_SIZE,"%s :Ha! You're not a Chan op",chan->name);
				send_numeric(client->fd,client->nick,482,buffer);
			}
			cmd_free(cmd);
			return EXIT_SUCCESS;	
		}
	}
	
}

/* Set a user mode for a channel */
/* only +o and +v supported */
/* easily add more */
static int chanuser_mode_set(struct clientinfo *effector,
			 struct channel *chan,
			 struct parsed_cmd *cmd)
{
	char * mode;
	struct user_wrap *curr_user;
	int i,j,found,givetake;
	struct user_wrap *user[6];

	mode=cmd->params[1];
			
	/* Get users into array */
	for(i=0;i<5;i++)
		user[i]=NULL;

	for(i=2;cmd->params[i];i++) {
		curr_user=chan->users_start;
		found=0;
		while(curr_user!=NULL && found==0) {
			if(cmd->params[i]!=NULL && lc_strncmp(curr_user->user_info->nick,cmd->params[i],-1)==0) {
				if(strcmp(curr_user->user_info->nick,cmd->params[i])!=0)
						/* change to correct case */
						strcpy(cmd->params[i],curr_user->user_info->nick);
				user[i-2]=curr_user;
				found=1;
			} else {
				curr_user=curr_user->next;
			}
		}
	}

	/* Actually set modes on clients */
	j=0;
	i=0;	
	givetake=0;
	for(j=0;mode[j]!='\0';j++) {
		switch(mode[j]) {
			case '+':
				givetake=1;
				break;
			case '-':
				givetake=-1;
				break;
			case 'o':
				if(user[i]!=NULL) {
					if(givetake==1)
						user[i]->chan_mode |= CHANUSR_OP;
					if(givetake==-1) 
						user[i]->chan_mode ^= CHANUSR_OP;
				}
				i++;
				break;
						
			case 'v':	
				if(user[i]!=NULL) {
					if(givetake==1) 
						/* Give voice */
						user[i]->chan_mode |= CHANUSR_VOICE;
					if(givetake==-1)
						/* Take voice */
						user[i]->chan_mode ^= CHANUSR_VOICE;
				} 
				
				i++;
				break;

			default:
				break;
		}
	}	

	/* Inform channels */	
	mode_inform_user(effector,chan,cmd);
	
	return EXIT_SUCCESS;
}

/* Inform channel of a chan_user mode change */
static int mode_inform_user(struct clientinfo *effector,
			    struct channel *chan,
			    struct parsed_cmd *cmd)
{
	struct user_wrap *curr_user;
	char buffer[BUF_SIZE];
	int i;
	
	ircd_sprintf(buffer,BUF_SIZE,"MODE %s %s %s",
				 	cmd->params[0], /* Channel */
				       	cmd->params[1], /* Mode code */
				       	cmd->params[2]); /* First user */
	
	/* Fill out rest of buffer */
	for(i=3;cmd->params[i]!=NULL;i++) {
		ircd_sprintf(buffer,BUF_SIZE,"%s %s",buffer,cmd->params[i]);
	}
	
	curr_user=chan->users_start;
	while(curr_user!=NULL) {
		send_to_fd(curr_user->user_info->fd,effector,buffer);
		curr_user=curr_user->next;
	}
			
	return EXIT_SUCCESS;
}	

/* return current channel mode to a user */
/* needs updating to include +l +k */
static int send_chancurr_mode(struct clientinfo *client,struct channel *chan) 
{
	char mode[10];
	int i=1;
	char buffer[BUF_SIZE];

	if(chan->mode!=0) {	
		mode[0]='+';
	
		/* Find out which modes are set */
		if(chan->mode & CMODE_TOPIC) {
			mode[i++]='t';
		}
		if(chan->mode & CMODE_INVONLY) {
			mode[i++]='i';
		}
		if(chan->mode & CMODE_MEMONLYSEND) {
			mode[i++]='n';
		}
		mode[i]='\0';
	} else {
		mode[0]='\0';
	}
	
	/* Send to user */
	ircd_sprintf(buffer,BUF_SIZE,"%s %s",chan->name,mode);
	send_numeric(client->fd,client->nick,324,buffer);
}

/* Set a channel mode */
static int set_chan_mode(struct clientinfo *client,
		         struct channel *chan,
			 struct parsed_cmd *cmd)
{
	struct user_wrap *curr_user;
	int i,givetake=0;
	char buffer[512];
	
	/* cmd->params[0] is the channel name */
	/* cmd->params[1] is the mode string */
	for(i=0;(cmd->params[1])[i];i++) {
		switch((cmd->params[1])[i]) {
			case '+':
				givetake=1;
				break;
			case '-':
				givetake=-1;
				break;
			case 't':
				if(givetake==1) {
					chan->mode |= CMODE_TOPIC;
					break;
				}
				if(givetake==-1) {
					chan->mode ^= CMODE_TOPIC;
					break;
				}
				break;
			case 'n':
				if(givetake==1) {
					chan->mode |= CMODE_MEMONLYSEND;
					break;
				}
				if(givetake==-1) {
					chan->mode ^= CMODE_MEMONLYSEND;
					break;
				}
				break;
		}
	}
	
	/* Inform users of change */
	curr_user=chan->users_start;
	ircd_sprintf(buffer,BUF_SIZE,"MODE %s %s",chan->name,cmd->params[1]);
	while(curr_user!=NULL) {
		send_to_fd(curr_user->user_info->fd,client,buffer);
		curr_user=curr_user->next;
	}
			
		

}
