#include "cmd_user.h"

extern int channels;
extern long int clients;
extern long int ops;
extern int services;

/* cmd_privmsg - deals with privmsg system */
int cmd_user(struct clientinfo *sender,struct parsed_cmd *cmd)
{
	int i,supp_mode;
	
	if(cmd->params[0]!=NULL) {
		strncpy(sender->user,cmd->params[0],NICK_LENGTH);
		sender->flags |= USR_NAME;
	}
	
	if(cmd->text!=NULL) {
		strncpy(sender->real_name,cmd->text,REAL_NAME_LENGTH);
	}	

	/* convert mode in cmd->params[1] to an int */
	/* mask it and add modes to cmd->mode	*/
	/* _don't_ just convert and add to struct */
	if(cmd->params[1]!=NULL) {
		supp_mode=atoi(cmd->params[1]);
	} else {
		supp_mode=0;
	}
	switch (supp_mode) {
		case MODE_INVIS | MODE_WALLOPS:
			sender->mode=MODE_INVIS ^ MODE_WALLOPS;
			break;
		case MODE_INVIS:
			sender->mode=MODE_INVIS;
			break;
		case MODE_WALLOPS:
			sender->mode=MODE_WALLOPS;
			break;
		default:
			sender->mode=0;
			break;
	}
	cmd_free(cmd);	
	sender->flags ^= USR_LOGGEDIN;
	sender->mode |= MODE_RESTRICT;
	return EXIT_SUCCESS;
}

/* sends info to user */
/* Really is very pointless */
int complete_login(struct clientinfo *client)
{
	char buffer[200];
	char modeline[10];
	
	/* Information */	
	sprintf(buffer,":Welcome to the Internet Relay network %s",client->nick);
	send_numeric(client->fd,client->nick,1,buffer);
	sprintf(buffer,":Your host is %s running Chunky Monkey IRC version %s",server_name,SERVER_VER);
	send_numeric(client->fd,client->nick,2,buffer);
	sprintf(buffer,":This server was created on %s",load_date);
	send_numeric(client->fd,client->nick,3,buffer);
	sprintf(buffer,"%s %s %s %s",server_name,SERVER_VER,user_modes,chan_modes);
	send_numeric(client->fd,client->nick,4,buffer);
	sprintf(buffer,":There are %d users, %d ops and %d services",clients,ops,services);
	send_numeric(client->fd,client->nick,251,buffer);
	send_numeric(client->fd,client->nick,375,"Message of the day");
	send_numeric(client->fd,client->nick,372,":");
	send_numeric(client->fd,client->nick,372,":This server is currently under development");
	send_numeric(client->fd,client->nick,372,":Please don't use it :)");
	send_numeric(client->fd,client->nick,372,":");
	send_numeric(client->fd,client->nick,376,":End of /MOTD");

	/* Set user mode */
	if(client->mode!=0) {
		/* Find out which modes are set */
		switch (client->mode) {
			case (MODE_INVIS | MODE_WALLOPS): 
				ircd_sprintf(buffer,200,"%s +%s","MODE","iw");
				send_to_fd(client->fd,client,buffer);
				break;

			case (MODE_INVIS):
				ircd_sprintf(buffer,200,"%s +%s","MODE","i");
				send_to_fd(client->fd,client,buffer);
				break;

			case (MODE_WALLOPS):
				ircd_sprintf(buffer,200,"%s +%s","MODE","w");
				send_to_fd(client->fd,client,buffer);
				break;
		
			default:
				break;
		}
	}
		
		
}
