#include "config_file.h"

/* Various def's set by this routine */
char server_name[30]="chunky.monkey.com";
char load_date[20];
char *motd[20];
char user_modes[10]="iwsOo";
char chan_modes[10]="nitm";
struct irc_op *irc_ops[10];

int parse_config_file(char *filename,struct sockaddr_in *myaddr)
{
	int conf_fd=-1;
	int len,i,numbytes,j;
	char buffer[1000];
	char *name;
	char *value;
	
	conf_fd=open(filename,O_RDONLY);

	if(conf_fd==-1) {
		fprintf(stderr,"\aFailed to open config file!!
				Are you sure it exists?\n");

		return EXIT_FAILURE;
	}

	/* pad out sock struct */
	myaddr->sin_family=AF_INET;
	myaddr->sin_port=htons(6667);
	myaddr->sin_addr.s_addr=INADDR_ANY;
	bzero(&(myaddr->sin_zero),8);

	/* Reset irc_ops array */
	for(i=0;i<MAX_OPS;i++) {
		irc_ops[i]=NULL;
	}
		

	/* read from disk */
	numbytes=read(conf_fd,buffer,1000);
	buffer[numbytes]='\0';
	
	/* Replace newlines and equals with \0 */	
	len=strlen(buffer);
	for(i=0;i<len;i++) {
		if(buffer[i]=='=' || buffer[i]=='\n') 
			buffer[i]='\0';
	}
	
	/* Actually set values */
	name=&(buffer[0]);
	value=NULL;
	j=1;
	for(i=0;i<len+1;i++) {
		if(buffer[i]=='\0' && j % 2 ==0) {
			j++;
			name=&(buffer[i+1]);
			value=NULL;
		} else {
			if(buffer[i]=='\0') {
				j++;
				value=&(buffer[i+1]);
			}
		}
		if(name!=NULL && value!=NULL) {
			set_values(name,value,myaddr);
			name=NULL;
			value=NULL;
		}
		
	}
		
}
	
static int set_values(char *key_name,char *value,
		      struct sockaddr_in *myaddr)
{
	char *op_buffer;
	char *op_name;
	char *op_pass;
	int str_len,i,found;
		
	if(lc_strncmp(key_name,"name",-1)==0) {
		strncpy(server_name,value,30);
		return;
	}
	if(lc_strncmp(key_name,"ip",-1)==0) {
		myaddr->sin_addr.s_addr=inet_addr(value);
		return;
	}
	if(lc_strncmp(key_name,"port",-1)==0) {
		myaddr->sin_port=htons(atoi(value));
		return;
	}
	if(lc_strncmp(key_name,"ircop",-1)==0) {
		/* Add a user to the ircop list */
		/* Copy to a buffer, for changing */
		str_len=strlen(value);
		op_buffer=string_alloc(str_len);
		strncpy(op_buffer,value,str_len);
		/* Set pointers to op name and op pass */
		op_name=op_buffer;
		for(i=0;i<str_len;i++) {
			if(op_buffer[i]==':') {
				op_buffer[i]='\0';
				op_pass=&(op_buffer[i+1]);
			}
		}
		found=0;
		for(i=0;i<MAX_OPS && found==0;i++) {
			if(irc_ops[i]==NULL) {
				irc_ops[i]=malloc(sizeof(struct irc_op));
				strcpy(irc_ops[i]->name,op_name);
				strcpy(irc_ops[i]->pass,op_pass);
				found=1;
			}
		}
		
		/* Free up allocated space */
		free(op_buffer);
		return;
	}
				
	
}
