#ifndef _IRCD_H_

#define _IRCD_H_

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <unistd.h>
#include <netdb.h>
#include "network.h"
#include "client.h"
#include "parse.h"
#include "cmd_n.h"
#include "cmd_privmsg.h"
#include "cmd_user.h"
#include "cmd_quit.h"
#include "cmd_mode.h"
#include "cmd_join.h"
#include "cmd_topic.h"
#include "channel.h"
#include "resolver.h"
#include <pthread.h>

/* should be about 1/3 of the ping time */
#define PING_SECS 90
#define SELECT_SECS 30
#define MAX 1000
#define BUF_SIZE 400

int serve_clients(int);
/* functions used internally */
static int request(int,
		   struct clientinfo *,
		   struct clientinfo *,
		   int *,
		   struct clientinfo **);
static int switch_reg_cmd(struct clientinfo *,
			  struct parsed_cmd *,
			  struct clientinfo *,
			  struct clientinfo **,
			  int *);
static int new_connection(struct clientinfo *,
		 	  struct clientinfo **,
			  int *,
			  int);
static int move_to_tree(struct clientinfo *,struct clientinfo *);

#endif
