#include "parse.h"
#include "utility.h"
#include "client.h"
#include "network.h"
#include "ircd.h"
#include "config_file.h"
#include <signal.h>

extern int signal_caught;

void * quit();

main()
{
	int socket;
	sigset_t newmask,oldmask;
	struct sigaction action;
	struct sockaddr_in myaddr;
	
	parse_config_file("./config",&myaddr);
	
	/* Call to get a socket */
	socket = setup_tcp(&myaddr);
	if(socket!=-1) {
		/* Setup signal handling, then go */
		sigemptyset(&newmask);
		sigaddset(&newmask,SIGINT);
		sigprocmask(SIG_BLOCK,&newmask,&oldmask);
		action.sa_flags=0;
		action.sa_handler=quit;
		sigaction(SIGHUP,&action,NULL);
		serv_clients(socket);
	} else {
		printf("Failed to get socket\n");
	}
}

void * quit()
{
	signal_caught=1;
}
