/* command parsing engine */
#include "parse.h"

/* parses a command */
struct parsed_cmd * parse_command(char *command)
{
	struct parsed_cmd * cmd;
	int i,cmd_len,start,j,last,end,str_len;
	char * text=NULL;
	char * params=NULL;
	char *cmd_start=NULL;
	

	/* Allocate memory for parsed cmd */
	cmd=malloc(sizeof(struct parsed_cmd));
	if(cmd==NULL) {
		return NULL;
	} else {
		cmd->text=NULL;
		cmd->command=NULL;
		for(i=0;i<15;i++)
			cmd->params[i]=NULL;	
	}	
	
	/* Strip \n\r off the end */
	str_len=strlen(command);
	for(i=str_len;command[i]=='\n' || command[i]=='\r' ||command[i]=='\0';i--) {
		command[i]='\0';
	}

	/* Locate start of text after : */
	last=0;
	str_len=strlen(command);
	for(i=str_len;i>=0;i--) {
		if(command[i]==':') {
			last=i;
			text=&(command[i+1]);
		}
	}	
	if(last!=0) 
		command[last]='\0';

	/* Copy text into cmd->text */
	if(text!=NULL && str_len==0) {
		/* Allocate one char for cmd->text */
		/* set it to \0 */
		cmd->text=string_alloc(1);
		cmd->text[0]='\0';
	} else {
		if(text==NULL) {
			cmd->text=NULL;
		} else {
			str_len=strlen(text);
			cmd->text=string_alloc(str_len);
			strncpy(cmd->text,text,str_len);
			cmd->text[str_len]='\0';
		}
	}
	
	
	/* Grab Command */
	str_len=strlen(command);
	if(command[0]==':') {
		/* Its prefixed */
		/* Find actual start */
		for(i=0;i<str_len;i++) {
			if(command[i]=' ') 
				cmd_start=&(command[i]);
		}
	 
	} else {
		cmd_start=command;	
	}

	
	str_len=strlen(cmd_start);
	for(i=0;params==NULL && i<str_len;i++) {
		if(cmd_start[i]==' ') {
			cmd_start[i]='\0';
			params=&(cmd_start[i+1]);
		}
	}

	/* Alloc space */
	cmd->command=string_alloc(i);
	strcpy(cmd->command,cmd_start);

	
	/* Process params list */
	if(params!=NULL) {
		str_len=strlen(params);
		last=0;
		j=0;
		for(i=0;i<str_len+1;i++) {
			if(params[i]==' ' || params[i]==',' || params[i]=='\0') {
				if(last!=i) {
					params[i]='\0';
					if( (i-last) < 101) {
						cmd->params[j]=string_alloc(i-last);
						strcpy(cmd->params[j++],&(params[last]));
					} else {
						cmd->params[j++]=NULL;
					}
					last=i+1;
				}
			}
		
		}
	}		
	return cmd;	
}

/* function called to clean up command structs */

int cmd_free(struct parsed_cmd * freeme)
{
	int i;
	
	if(freeme==NULL)
		return EXIT_SUCCESS;
	
	/* Free text and command storage */	
	if(freeme->text!=NULL)
		free(freeme->text);
	if(freeme->command!=NULL)
		free(freeme->command);

	/* Loop though parameter array */
	/* free each if needed */
	if(freeme->params[0]!=NULL)
		for(i=0;freeme->params[i]!=NULL;i++) 
			free(freeme->params[i]);
	
	/* Free main structure */
	free(freeme);

	return EXIT_SUCCESS;
}

