#include "resolver.h"

void * resolve_thread_create()
{	
	/* Receive buffer */
	char buffer[100];
	/* Unix Socket Structure */
	struct sockaddr_un my_addr;
	int sockfd,clientfd,numbytes;
	struct parsed_cmd *p_cmd;	
	
	/* Set up local socket */
	my_addr.sun_family=AF_UNIX;
	strcpy(my_addr.sun_path,RESOLVER_PATH);

	sockfd=setup_socket(&my_addr);

	if(sockfd==-1) {
		printf("Failed to get socket for IRCD communication\n");
		exit(EXIT_FAILURE);
	}
	
	/* Accept connection from IRCD when it's ready */
	printf("Waiting to accept server connection\n");
	clientfd=accept(sockfd,NULL,NULL);
	
	if(clientfd==-1) {
		printf("Failed to accept connection\n");
		exit(EXIT_FAILURE);
	}
	
	printf("Successfully connected to by ircd\n");
	while(1) {
		numbytes=recv(clientfd,buffer,100,0);	
		buffer[numbytes]='\0';
		/* Use server parsing engine */
		p_cmd=parse_command(buffer);	

		printf("should resolve %s\n",p_cmd->command);
		cmd_free(p_cmd);
	}
	

}


/* Sets up local socket */
static int setup_socket(struct sockaddr_un *my_addr)
{
	int sock;

	sock=socket(AF_UNIX,SOCK_STREAM,0);
	
	if(sock==-1) 
		return -1;
	
	unlink(RESOLVER_PATH);
	
	if(bind(sock,(struct sockaddr *)my_addr,sizeof(struct sockaddr))==-1) {
		printf("Failed to bind\n");
		perror("bind");
		close(sock);
		return -1;
	}

	if(listen(sock,1)==-1) {
		printf("Failed to get socket for listening\n");
		perror("listen");
		close(sock);
		return -1;
	}

	return sock;
}
